/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3	STRLIB:		STRING MANIPULATION LIBRARY		     */


#ifndef __XC_STRLIB_H
#define __XC_STRLIB_H


/* Standard C Library: */
#include <stddef.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

/* eXtended C Library: */
#include <xc/cdecl.h>		/* C DECLARATIONS			     */


#ifndef strdupa
#define strdupa(s)					\
_FBEGIN							\
    const char *___old = (s);				\
    size_t      ___siz;					\
    char       *___new;					\
							\
    assert(___old != NULL);				\
							\
    ___siz = strlen(___old) + 1;			\
							\
    ___new = alloca(___siz);				\
							\
    if (___new != NULL) memcpy(___new, ___old, ___siz);	\
							\
    ___new;						\
_FEND
#endif


_CDECL_BEGIN

int asprintf(char **pstr, const char *format, ...)
 __attribute__ ((__format__ (__printf__, 2, 3)));
int vasprintf(char **pstr, const char *format, va_list vargs)
 __attribute__ ((__format__ (__printf__, 2, 0)));

#ifdef __GLIBC__
int snprintf(char *buf, size_t size, const char *format, ...)
 __attribute__ ((__format__ (__printf__, 3, 4)));
int vsnprintf(char *buf, size_t size, const char *format, va_list vargs)
 __attribute__ ((__format__ (__printf__, 3, 0)));
#else
#define snprintf	__xclib(snprintf)
#define vsnprintf	__xclib(vsnprintf)
int __xclib(snprintf)(char *buf, size_t size, const char *format, ...)
 __attribute__ ((__format__ (__printf__, 3, 4)));
int __xclib(vsnprintf)(char *buf, size_t size, const char *format, va_list vargs)
 __attribute__ ((__format__ (__printf__, 3, 0)));
#endif

char *strlow(char *s);
char *strupp(char *s);

#ifdef	strdup
#if defined __VERBOSE__ || defined __PARANOID__
#warning "INFO: Macro version of `strdup()' is used"
#endif
#else
char *strdup(const char *s);
#endif
char *stradd(char *s1, const char *s2);

void *memdup(const void *ptr, size_t size);
void *memadd(void *ptr1, size_t size1, const void *ptr2, size_t size2);

_CDECL_END


#endif /* XC STRLIB HEADER */


/*------------------------------/ END OF FILE /------------------------------*/
