/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3:	A SET OF C FUNCTIONS FOR GENERAL PURPOSES		     */


/* POSIX: */
#include <sys/types.h>
#include <sys/time.h>

/* Standard C Library: */
#include <stddef.h>
#include <stdarg.h>
#ifdef HAVE_STDINT_H
#include <stdint.h> /*  EXPERIMENTAL (if you have any problem, mail me) */
#endif
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <assert.h>

/* eXtended C Library: */
#include <xc/List.h>		/* SINGLY LINKED LIST			     */
#include <xc/ListD.h>		/* SINGLY LINKED LIST WITH SENTINELS	     */
#include <xc/LList.h>		/* DOUBLY LINKED LIST			     */
#include <xc/LListD.h>		/* DOUBLY LINKED LIST WITH SENTINELS	     */
#include <xc/CList.h>		/* CIRCULAR SINGLY LINKED LIST		     */
#include <xc/CListD.h>		/* CIRCULAR SINGLY LINKED LIST WITH SENTINEL */
#include <xc/CLList.h>		/* CIRCULAR DOUBLY LINKED LIST		     */
#include <xc/CLListD.h>		/* CIRCULAR DOUBLY LINKED LIST WITH SENTINEL */
#include <xc/defines.h>		/* SOME CLASSIC DEFINES			     */
#include <xc/colors.h>		/* DISPLAY COLORIZATION			     */
#ifdef __EXPERIMENTAL__
#include <xc/errors.h>		/* SOME COMMON ERRORS			     */
#endif
#include <xc/macros.h>		/* SOME USEFUL MACROS			     */
#include <xc/types.h>		/* DEFINITION OF USEFUL TYPES		     */
#include <xc/library.h>		/* LIBRARY INFORMATIONS			     */
#include <xc/program.h>		/* PROGRAM INVOCATION NAME		     */
#ifdef __EXPERIMENTAL__
#include <xc/options.h>		/* PARSE COMMAND LINE OPTIONS		     */
#endif
#include <xc/missing.h>		/* MISSING FUNCTIONS			     */
#include <xc/time.h>		/* POSIX TIME SERVICE			     */
#include <xc/timer.h>		/* SIMPLIFIED TIMER INTERFACE		     */
#include <xc/strlib.h>		/* STRING MANIPULATION LIBRARY		     */
#include <xc/base.h>		/* PRIMARY FUNCTIONS			     */
#include <xc/error.h>		/* ERROR HANDLING FACILITY		     */
#include <xc/trace.h>		/* TRACE FACILITY			     */
#ifdef __EXPERIMENTAL__
#include <xc/math.h>		/* EXTRA MATHEMATIC FUNCTIONS		     */
#endif
#include <xc/dynarr.h>		/* DYNAMIC MULTI-DIMENSIONAL ARRAY	     */
#include <xc/xalloc.h>		/* PROTECTED MEMORY ALLOCATION FUNCTIONS     */
#include <xc/list.h>		/* GENERIC LIST				     */
#include <xc/io.h>		/* SYNCHRONOUS I/O MULTIPLEXING		     */
#include <xc/ioaux.h>		/* SYNCHRONOUS I/O MULTIPLEXING (ADD-ON)     */
#ifdef __EXPERIMENTAL__
#include <xc/geom.h>		/* GEOMETRIC COMPUTATION		     */
#endif


/*------------------------------/ END OF FILE /------------------------------*/
