/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : STRING MANIPULATION LIBRARY
  | Version : 0.3
  | Language: ANSI C
  | File    : strlib/stradd.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


#define _XCLIB_INTERNALS

#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "xc/strlib.h"

#include "global.h"

char *stradd(char *const s1, const char *const s2)
{
    size_t len1, len2;
    char  *new;

    assert(s1 != NULL && s2 != NULL);

    len1 = strlen(s1);
    len2 = strlen(s2);

    new = realloc(s1, len1 + len2 + 1);

    if (new == NULL) return NULL;

#if	0
    strcat(new, s2);			/* Version classique		*/
#elif	0
    memcpy(new + len1, s2, len2 + 1);	/* Plus efficace		*/
#else
    memmove(new + len1, s2, len2 + 1);	/* Permet de faire stradd(s, s)	*/
#endif

    return new;
}


/* End Of File */
