/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : TRACE FACILITY
  | Version : 0.3
  | Language: ANSI C
  | File    : trace/trace.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


#define _XCLIB_INTERNALS

#include <stdarg.h>

#include "trace/intern.h"

#include "xc/trace.h"

typedef const char *String;

typedef const String CString;

void __xclib(trace)(CString format, ...)
{
    struct info info;

    va_list vargs;

    info.faci = "";
    info.file = "";
    info.line = 0;

    va_start(vargs, format);
    __xcint(trace)(&info, format, vargs);
    va_end(vargs);
}

void __xclib(trace_in)(CString function, ...)
{
    struct info info;

    va_list vargs;

    info.faci = "";
    info.file = "";
    info.line = 0;

    va_start(vargs, function);
    __xcint(trace_in)(&info, function, vargs);
    va_end(vargs);
}

void __xclib(trace_out)(CString function, ...)
{
    struct info info;

    va_list vargs;

    info.faci = "";
    info.file = "";
    info.line = 0;

    va_start(vargs, function);
    __xcint(trace_out)(&info, function, vargs);
    va_end(vargs);
}


/* End Of File */
