#include <stddef.h>
#include <stdio.h>
#include <assert.h>

#include "xc/CList.h"
#include "xc/xalloc.h"

typedef struct node *Node;
typedef struct list *List;

struct node
{
    struct node *next;

    int data;
};

struct list
{
    struct node *link;
};

static void print(struct list *list);

int main()
{
    struct list *list;
    struct node *node1;
    struct node *node2;
    struct node *node3;
    struct node *node4;
    struct node *node5;

    list = xnew(List);
    CL_INIT(list);
    print(list);

    (node1 = xnew(Node))->data = 1;
    CL_APPEND(list, node1);
    print(list);

    (node2 = xnew(Node))->data = 2;
    CL_APPEND(list, node2);
    print(list);

    (node3 = xnew(Node))->data = 3;
    CL_APPEND(list, node3);
    print(list);

    (node4 = xnew(Node))->data = 4;
    CL_INSERT(list, node4);
    print(list);

    (node5 = xnew(Node))->data = 5;
    CL_INSERT_BEFORE(list, node5, node4);
    print(list);

    CL_REMOVE(list, node5);
    xfree(node5);
    print(list);

    CL_REMOVE(list, node3);
    xfree(node3);
    print(list);

    CL_ACTION(list, xfree(__node););
    xfree(list);

    return 0;
}

static void print(struct list *list)
{
    assert(list != NULL);

    fputs("List: (", stdout);

    if (list->link != NULL)
    {
	printf(" %d", list->link->data);

	_CL_FOREACH_NODE(list->link, printf(" %d", __node->data););
    }

    puts(" )");
}
