#include <stddef.h>
#include <stdio.h>
#include <assert.h>

#include "xc/CListD.h"
#include "xc/xalloc.h"

typedef struct node *Node;
typedef struct list *List;

struct node
{
    struct node *next;

    int data;
};

struct list
{
    struct node *link; /* sentinel */
};

static void print(struct list *list);

int main()
{
    struct list *list;
    struct node *node1;
    struct node *node2;
    struct node *node3;
    struct node *node4;
    struct node *node5;

    list = xnew(List);
    list->link = xnew(Node);
    CLD_INIT(list);
    print(list);

    (node1 = xnew(Node))->data = 1;
    CLD_APPEND(list, node1);
    print(list);

    (node2 = xnew(Node))->data = 2;
    CLD_APPEND(list, node2);
    print(list);

    (node3 = xnew(Node))->data = 3;
    CLD_APPEND(list, node3);
    print(list);

    (node4 = xnew(Node))->data = 4;
    CLD_INSERT(list, node4);
    print(list);

    (node5 = xnew(Node))->data = 5;
    CLD_INSERT_BEFORE(list, node5, node4);
    print(list);

    CLD_REMOVE(list, node5);
    xfree(node5);
    print(list);

    CLD_REMOVE(list, node3);
    xfree(node3);
    print(list);

    CLD_ACTION(list, xfree(__node););
    xfree(list->link);
    xfree(list);

    return 0;
}

static void print(struct list *list)
{
    assert(list != NULL);

    fputs("List: (", stdout);

    CLD_FOREACH_NODE(list, printf(" %d", __node->data););

    puts(" )");
}
