/*****************************************************************************\

Sous Linux avec la GLIBC version 2.1.3: DBL_MIN * DBL_MAX == 4

\*****************************************************************************/

#define _XCLIB_SOURCE

#include <errno.h>
#include <float.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#include "xc/macros.h"
#include "xc/timer.h"
#include "xc/xalloc.h"
#include "xc/math.h"

#define TYPE double

#define WITH_TIMER 0

#if WITH_TIMER
typedef const struct timer *Timer;
#endif

static void print_fresult(TYPE result);

int main()
{
#if 0
    TYPE *table;
    int   count;
#else
    TYPE  table[] = { DBL_MAX, DBL_MAX };
    TYPE  count   = cardinal(table);
#endif
    TYPE  value;
#if WITH_TIMER
    Timer timer;
#endif
    int   i;

#if 0
    count = 1000;
    table = xmalloc(count * sizeof (TYPE));

    for (i = 0; i < count; i++) table[i] = i;
#endif

#if 0
    _math_flags  = 0;
    _math_flags |= _mathFast;
    _math_flags |= _mathNoRangeChecking;
#endif

#if WITH_TIMER
    timer = timer_ctl(NULL, timerNEW | timerSET);

    for (i = 0; i < 1000; ++i)
    {
#endif
	value = fmul(table, count);

#if WITH_TIMER
	timer_ctl(timer, timerTOP);
    }

    timer_ctl(timer, timerPUT | timerDEL);
#endif

    if ((value == +DBL_MAX || value == -DBL_MAX) && errno)
	puts(strerror(errno));
    else
	print_fresult(value);

    return 0;
}

static void print_fresult(TYPE result)
{
    if (result > 0)
    {
	if (result == HUGE_VAL)
	    printf("result = Infinity\n");
	else if (result == DBL_MAX)
	    printf("result = DBL_MAX\n");
	else
	    printf("result = %g\n", result);
    }
    else if (result < 0)
    {
	if (result == -HUGE_VAL)
	    printf("result = -Infinity\n");
	else if (result == -DBL_MAX)
	    printf("result = -DBL_MAX\n");
	else
	    printf("result = %g\n", result);
    }
    else
    {
	printf("result = ZERO\n");
    }
}
