############################################################## -*- makefile -*-
#
#	Copyright (C) 1996-2001  Martin Vicente
#	This file is part of the eXtended C Library (XCLIB).
#
#	This library is free software; you can redistribute it and/or
#	modify it under the terms of the GNU Library General Public
#	License as published by the Free Software Foundation; either
#	version 2 of the License, or (at your option) any later version.
#
#	This library is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#	Library General Public License for more details.
#
#	You should have received a copy of the GNU Library General Public
#	License along with this library (see the file COPYING.LIB).
#	If not, write to the Free Software Foundation, Inc.,
#	59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#
###############################################################################
#
#	HELP-OPTIONS TARGET
#
# Warning: This is an include file for GNU makefiles only.
#
#	Project : "Les outils de Martin"
#	Purpose : `help-options' target for GNU makefile
#	File    : utils/help-options.mk
#	Version : 1.1
#	Language: GNU Make
#	Author  : Martin Vicente
#	Contact : martin@vicente.org (or martin.vicente@free.fr)
#	Revision: Mon, 14 May 2001
#
###############################################################################

ifneq (,)
This makefile requires GNU Make.
endif

ifndef   __UTILS_HELP_OPTIONS_MK
override __UTILS_HELP_OPTIONS_MK := OK

#==============================================================================

override UTILS ?= $(HOME)/devel/utils

include $(UTILS)/color.mk		# DISPLAY COLORIZATION

#====( DEFINITIONS )

override _1 := "Environment:"
override _2 :=
override _3 := "    "$(bold)"TRACE"$(bold_off)"   :"\
" Disable/Enable trace facility at compile time"
override _4 := "    "$(bold)"DEBUG"$(bold_off)"   :"\
" Disable/Enable generation of debugging information"
override _5 := "    "$(bold)"OPTIMIZE"$(bold_off)":"\
" Disable/Enable code optimization"
override _6 :=
override _7 := "    Valid values are: "\
$(bold)"0"$(bold_off)"/"$(bold)"No"$(bold_off)"/"$(bold)"False"$(bold_off)\
" and "\
$(bold)"1"$(bold_off)"/"$(bold)"Yes"$(bold_off)"/"$(bold)"True"$(bold_off)

override count := 1 2 3 4 5 6 7

override HELP_OPTIONS := $(foreach n, $(count), $(_$n)\\n)

#====( RULES )

help-options: usage ; @ $(ECHO_E) $(green)$(HELP_OPTIONS)$(reset)

.PHONY: help-options

#==============================================================================

endif  # __UTILS_HELP_OPTIONS_MK

# [END OF FILE]
